/*===========================================================================*/
/*   (Llib/pcondvar.scm)                                                     */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -unsafe -safee -copt -fPIC -copt -IPosix Llib/pcondvar.scm -o objs/objs_u/pcondvar.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>
#include <bglpthread.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL___PTH_CONDVAR_TYPE_DEFINITIONS
#define BGL___PTH_CONDVAR_TYPE_DEFINITIONS
#endif // BGL___PTH_CONDVAR_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_requirezd2initializa7ationz75zz__pth_condvarz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_conditionzd2variablezd2specificzd2setz12zc0zz__pth_condvarz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__pth_condvarz00(void);
static obj_t BGl_objectzd2initzd2zz__pth_condvarz00(void);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62conditionzd2variablezd2specificzd2setz12za2zz__pth_condvarz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__pth_condvarz00(void);
BGL_EXPORTED_DECL obj_t BGl_conditionzd2variablezd2specificz00zz__pth_condvarz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__pth_condvarz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl__makezd2pcondvarzd2zz__pth_condvarz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__pth_condvarz00(void);
static obj_t BGl_libraryzd2moduleszd2initz00zz__pth_condvarz00(void);
static obj_t BGl_gczd2rootszd2initz00zz__pth_condvarz00(void);
BGL_EXPORTED_DECL obj_t BGl_makezd2pcondvarzd2zz__pth_condvarz00(obj_t);
static obj_t BGl_z62conditionzd2variablezd2specificz62zz__pth_condvarz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t __cnst[ 1 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_conditionzd2variablezd2specificzd2envzd2zz__pth_condvarz00, BgL_bgl_za762conditionza7d2v1037z00, BGl_z62conditionzd2variablezd2specificz62zz__pth_condvarz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2pcondvarzd2envz00zz__pth_condvarz00, BgL_bgl__makeza7d2pcondvar1038za7, opt_generic_entry, BGl__makezd2pcondvarzd2zz__pth_condvarz00, BFALSE, -1 );
DEFINE_STRING( BGl_string1029z00zz__pth_condvarz00, BgL_bgl_string1029za700za7za7_1039za7, "/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/api/pthread/src/Llib/pcondvar.scm", 85 );
DEFINE_STRING( BGl_string1030z00zz__pth_condvarz00, BgL_bgl_string1030za700za7za7_1040za7, "_make-pcondvar", 14 );
DEFINE_STRING( BGl_string1031z00zz__pth_condvarz00, BgL_bgl_string1031za700za7za7_1041za7, "vector", 6 );
DEFINE_STRING( BGl_string1032z00zz__pth_condvarz00, BgL_bgl_string1032za700za7za7_1042za7, "&condition-variable-specific", 28 );
DEFINE_STRING( BGl_string1033z00zz__pth_condvarz00, BgL_bgl_string1033za700za7za7_1043za7, "condvar", 7 );
DEFINE_STRING( BGl_string1034z00zz__pth_condvarz00, BgL_bgl_string1034za700za7za7_1044za7, "&condition-variable-specific-set!", 33 );
DEFINE_STRING( BGl_string1035z00zz__pth_condvarz00, BgL_bgl_string1035za700za7za7_1045za7, "condvar ", 8 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_conditionzd2variablezd2specificzd2setz12zd2envz12zz__pth_condvarz00, BgL_bgl_za762conditionza7d2v1046z00, BGl_z62conditionzd2variablezd2specificzd2setz12za2zz__pth_condvarz00, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__pth_condvarz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__pth_condvarz00(long BgL_checksumz00_46, char * BgL_fromz00_47)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__pth_condvarz00))
{ 
BGl_requirezd2initializa7ationz75zz__pth_condvarz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__pth_condvarz00(); 
BGl_libraryzd2moduleszd2initz00zz__pth_condvarz00(); 
BGl_cnstzd2initzd2zz__pth_condvarz00(); 
return 
BGl_methodzd2initzd2zz__pth_condvarz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(0L, "__pth_condvar"); 
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "__pth_condvar"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(0L, "__pth_condvar"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(0L, "__pth_condvar"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "__pth_condvar"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_cportz00_35;
{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_stringz00_42;
BgL_stringz00_42 = BGl_string1035z00zz__pth_condvarz00; 
{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_startz00_43;
BgL_startz00_43 = 
BINT(0L); 
{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_endz00_44;
BgL_endz00_44 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_42))); 
{ /* Llib/pcondvar.scm 15 */

BgL_cportz00_35 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_42, BgL_startz00_43, BgL_endz00_44); } } } } 
{ 
 long BgL_iz00_36;
BgL_iz00_36 = 0L; 
BgL_loopz00_37:
if(
(BgL_iz00_36==(-1L)))
{ /* Llib/pcondvar.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/pcondvar.scm 15 */
{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_arg1036z00_38;
{ /* Llib/pcondvar.scm 15 */

{ /* Llib/pcondvar.scm 15 */
 obj_t BgL_locationz00_40;
BgL_locationz00_40 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pcondvar.scm 15 */

BgL_arg1036z00_38 = 
BGl_readz00zz__readerz00(BgL_cportz00_35, BgL_locationz00_40); } } } 
{ /* Llib/pcondvar.scm 15 */
 int BgL_tmpz00_69;
BgL_tmpz00_69 = 
(int)(BgL_iz00_36); 
CNST_TABLE_SET(BgL_tmpz00_69, BgL_arg1036z00_38); } } 
{ /* Llib/pcondvar.scm 15 */
 int BgL_auxz00_41;
BgL_auxz00_41 = 
(int)(
(BgL_iz00_36-1L)); 
{ 
 long BgL_iz00_74;
BgL_iz00_74 = 
(long)(BgL_auxz00_41); 
BgL_iz00_36 = BgL_iz00_74; 
goto BgL_loopz00_37;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* _make-pcondvar */
obj_t BGl__makezd2pcondvarzd2zz__pth_condvarz00(obj_t BgL_env1014z00_5, obj_t BgL_opt1013z00_4)
{
{ /* Llib/pcondvar.scm 26 */
{ /* Llib/pcondvar.scm 26 */

{ /* Llib/pcondvar.scm 26 */
 long BgL_aux1016z00_19;
{ 
 obj_t BgL_auxz00_77;
if(
VECTORP(BgL_opt1013z00_4))
{ /* Llib/pcondvar.scm 26 */
BgL_auxz00_77 = BgL_opt1013z00_4
; }  else 
{ 
 obj_t BgL_auxz00_80;
BgL_auxz00_80 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1029z00zz__pth_condvarz00, 
BINT(1415L), BGl_string1030z00zz__pth_condvarz00, BGl_string1031z00zz__pth_condvarz00, BgL_opt1013z00_4); 
FAILURE(BgL_auxz00_80,BFALSE,BFALSE);} 
BgL_aux1016z00_19 = 
VECTOR_LENGTH(BgL_auxz00_77); } 
switch( BgL_aux1016z00_19) { case 0L : 

{ /* Llib/pcondvar.scm 26 */
 obj_t BgL_namez00_20;
BgL_namez00_20 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
((obj_t)
CNST_TABLE_REF(0))); 
{ /* Llib/pcondvar.scm 26 */

return 
bglpth_make_condvar(BgL_namez00_20);} } break;case 1L : 

{ /* Llib/pcondvar.scm 26 */
 obj_t BgL_namez00_21;
{ 
 obj_t BgL_auxz00_89;
if(
VECTORP(BgL_opt1013z00_4))
{ /* Llib/pcondvar.scm 26 */
BgL_auxz00_89 = BgL_opt1013z00_4
; }  else 
{ 
 obj_t BgL_auxz00_92;
BgL_auxz00_92 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1029z00zz__pth_condvarz00, 
BINT(1415L), BGl_string1030z00zz__pth_condvarz00, BGl_string1031z00zz__pth_condvarz00, BgL_opt1013z00_4); 
FAILURE(BgL_auxz00_92,BFALSE,BFALSE);} 
BgL_namez00_21 = 
VECTOR_REF(BgL_auxz00_89,0L); } 
{ /* Llib/pcondvar.scm 26 */

return 
bglpth_make_condvar(BgL_namez00_21);} } break;
default: 
return BUNSPEC;} } } } 

}



/* make-pcondvar */
BGL_EXPORTED_DEF obj_t BGl_makezd2pcondvarzd2zz__pth_condvarz00(obj_t BgL_namez00_3)
{
{ /* Llib/pcondvar.scm 26 */
return 
bglpth_make_condvar(BgL_namez00_3);} 

}



/* condition-variable-specific */
BGL_EXPORTED_DEF obj_t BGl_conditionzd2variablezd2specificz00zz__pth_condvarz00(obj_t BgL_mz00_6)
{
{ /* Llib/pcondvar.scm 32 */
return 
BGLPTH_CONDVAR_SPECIFIC(BgL_mz00_6);} 

}



/* &condition-variable-specific */
obj_t BGl_z62conditionzd2variablezd2specificz62zz__pth_condvarz00(obj_t BgL_envz00_22, obj_t BgL_mz00_23)
{
{ /* Llib/pcondvar.scm 32 */
{ /* Llib/pcondvar.scm 33 */
 obj_t BgL_auxz00_101;
if(
BGL_CONDVARP(BgL_mz00_23))
{ /* Llib/pcondvar.scm 33 */
BgL_auxz00_101 = BgL_mz00_23
; }  else 
{ 
 obj_t BgL_auxz00_104;
BgL_auxz00_104 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1029z00zz__pth_condvarz00, 
BINT(1767L), BGl_string1032z00zz__pth_condvarz00, BGl_string1033z00zz__pth_condvarz00, BgL_mz00_23); 
FAILURE(BgL_auxz00_104,BFALSE,BFALSE);} 
return 
BGl_conditionzd2variablezd2specificz00zz__pth_condvarz00(BgL_auxz00_101);} } 

}



/* condition-variable-specific-set! */
BGL_EXPORTED_DEF obj_t BGl_conditionzd2variablezd2specificzd2setz12zc0zz__pth_condvarz00(obj_t BgL_mz00_7, obj_t BgL_vz00_8)
{
{ /* Llib/pcondvar.scm 38 */
BGLPTH_CONDVAR_SPECIFIC_SET(BgL_mz00_7, BgL_vz00_8); BUNSPEC; 
return BgL_vz00_8;} 

}



/* &condition-variable-specific-set! */
obj_t BGl_z62conditionzd2variablezd2specificzd2setz12za2zz__pth_condvarz00(obj_t BgL_envz00_24, obj_t BgL_mz00_25, obj_t BgL_vz00_26)
{
{ /* Llib/pcondvar.scm 38 */
{ /* Llib/pcondvar.scm 39 */
 obj_t BgL_auxz00_110;
if(
BGL_CONDVARP(BgL_mz00_25))
{ /* Llib/pcondvar.scm 39 */
BgL_auxz00_110 = BgL_mz00_25
; }  else 
{ 
 obj_t BgL_auxz00_113;
BgL_auxz00_113 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1029z00zz__pth_condvarz00, 
BINT(2092L), BGl_string1034z00zz__pth_condvarz00, BGl_string1033z00zz__pth_condvarz00, BgL_mz00_25); 
FAILURE(BgL_auxz00_113,BFALSE,BFALSE);} 
return 
BGl_conditionzd2variablezd2specificzd2setz12zc0zz__pth_condvarz00(BgL_auxz00_110, BgL_vz00_26);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__pth_condvarz00(void)
{
{ /* Llib/pcondvar.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
